package com.imooc.utils;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;

/**
 * Htpp 请求工具类
 * Created by xuwei
 */
public class HttpUtil {
    /**
     * post 请求
     * @param url
     * @param jsonObj
     * @return
     */
    public static JSONObject doPost(String url, JSONObject jsonObj){
        DefaultHttpClient client = new DefaultHttpClient();
        HttpPost post = new HttpPost(url);
        JSONObject response = null;
        try {
            StringEntity s = new StringEntity(jsonObj.toString());
            s.setContentEncoding("UTF-8");
            //发送json数据需要设置contentType
            s.setContentType("application/json");
            post.setEntity(s);
            HttpResponse res = client.execute(post);
            if(res.getStatusLine().getStatusCode() == HttpStatus.SC_OK){
                HttpEntity entity = res.getEntity();
                // 返回json格式
                String result = EntityUtils.toString(entity);
                response = JSON.parseObject(result);
            }
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
            client.close();
        }
        return response;
     }

    /**
     * 测试post请求
     * @param args
     */
    public static void main(String[] args) {
        String url = "http://localhost:8080/v1/ua";
        JSONObject jsonObj = new JSONObject();
        jsonObj.put("name","tom");
        jsonObj.put("age",18);
        JSONObject res = doPost(url,jsonObj);
        System.out.println(res.toString());
    }
}
